;------- TASM ASM mnemonics. -------
; Compile this file using:
; Set TASMOPTS = -b
; tasm -80 ThisCode.tas MyBinary.BIN
;-----------------------------------
; Zx81 Program name: 

#define ORG  .org       ; TASM cross-assembler definitions
#define equ  .equ
#define db  .db
#define dw .word 
;-----------------------------------

#include "ZX81.sym" ; Load the symbol file.

;Uncompress
ORG 16514
	CALL MAIN
	RET
MAIN:
	LD HL,(RAM_D_FILE); LOAD VIDEO ADDRESS
	LD DE,XBUFFER     ; LOAD COMPRESS DATAS ADDRESS
	INC HL

Ret1:
	LD A,$01
	LD (SetVal+2),A   ;NOT A MULTI-CHAR (B.)
	LD A,(DE)         ;GET BUFFER DATA
	BIT 6,A           ;TEST IF IT'S A MULTI-CHAR
	RES 6,A           ;REMOVE MULTI-CHAR TAG
	LD (SetVal+1),A   ; SAVE CLEANED VALUE (.C)
	JR Z,SetVal       ;Z=0 NOT A MULTI-CHAR (B=1)
REP1:
	INC DE            ; SET B COUNTER FROM (DE+1)
	LD A,(DE)         ;GET MULTI-CHAR REPEAT VALUE
	LD (SetVal+2),A   ;SAVE VALUE
	CP $01            ;Z=0 IF MULTI-CHAR REPEAT VALUE
	RET Z             ; IS THE EXIT TAG.-> EXIT

SetVal:
	LD BC,$0100       ; SET B COUNTER TO SINGLE CHAR(SetVal+2)
                          ; SET C VALUE (SetVal+1)
JpEol:
	LD (HL),C         ;-> PRINT TO VIDEO MEMORY
	INC HL
	BIT 6,(HL)        ;TEST IF IT'S THE END OF LINE TAG
	JR Z,JpEol1       ; $76 Z=0 -> PRINT TO VIDEO MEMORY
	INC HL            ; $76 Z=1 -> INCREMENT VIDEO OFFSET
JpEol1:
	DJNZ JpEol        ;REPEAT USING B REGISTER (B=1 OR B=(DE+1)
	INC DE
	JR Ret1

XBUFFER:
.end


